if ENV['COVERAGE'] == '1'
  require 'simplecov'
  SimpleCov.start do
	add_filter "/test/"
  end
end
require 'minitest/autorun'
require 'minitest/pride'

require_relative '../lib/mxhero-api'

# Load fixtures
Dir["#{File.dirname(__FILE__)}/fixtures/**/*.rb"].each { |rb| require rb }

TEST_API_DOMAIN   = ENV['TEST_API_DOMAIN'] || 'tesla.com'
TEST_API_URL      = ENV['TEST_API_URL'] || 'http://test.mxhero.com/webapi/api/v1'
TEST_API_USER     = 'admin'
TEST_API_PASSWORD = ENV['TEST_API_PASSWORD'] || 'password' 

require 'vcr'

VCR.configure do |c|
  c.cassette_library_dir = 'test/fixtures/api'
  c.allow_http_connections_when_no_cassette = true
  c.hook_into :webmock
end

