require_relative 'helper'

class User < DTO.new(:first_name, :last_name)
end

class DTOTest < Minitest::Test
  def setup
    @user = User.new(first_name: 'John', last_name: 'Doe', another: 'Yeah!')
  end

  def test_accessors
    assert_equal 'John', @user.first_name
    assert_equal 'Doe', @user.last_name
    refute @user.respond_to? :another
  end

  def test_to_json
    assert_equal({ first_name: 'John', last_name: 'Doe' }.to_json, @user.to_json)
    another = Class.new(DTO.new :first_name, :childs )
    with_childs = another.new(first_name: 'Jess', childs: [ 'Albert', 'Margo' ])
    assert_equal({ first_name: 'Jess', childs: ['Albert', 'Margo']}.to_json, with_childs.to_json)
  end

  def test_to_s
    expected = "first_name: John, last_name: Doe" 
    assert_equal expected, @user.to_s
  end
end
