require_relative 'helper'

class EmailSyncTest < Minitest::Test
	def setup
		@emailsync = MxHero::API::EmailSync.new(username: TEST_API_USER, 
			password: TEST_API_PASSWORD, verbose: false, 
			api_url: TEST_API_URL)
	end

	def domain
		TEST_API_DOMAIN
	end

=begin
	
[{
	taskId: "031ad948-8e56-4035-a976-aa6400b0b261",
	domain: "mxhero.com",
	createdAt: 1467124478933,
	updatedAt: 1467124497158,
	status: "finished",
	type: "normal",
	lastErrorCode: null,
	configuration: {
		type: "normal",
		accounts: [
			"jproyo@mxhero.com"
		],
		rateLimit: 20,
		maxErrorTryPerAccount: 10,
		period: {
			repeatEverySeconds: null,
			until: null
		},
		imap: {
			type: "gapps",
			credentials: {},
			filterSearch: {
				date: {
					from: 1467072000000,
					to: 1467158400000
				},
				fromTo: {
					upload: [],
					ignore: []
				},
				folders: {
					inclusion: [
						"Inbox"
					],
					exclusion: []
				}
			}
		},
		cloudStorage: {
			adminAccount: "jproyo@mxhero.com",
			storageAccount: "jproyo@mxhero.com",
			appAuthId: null,
			storageType: "box",
			mappingAccounts: []
		},
		folderStorage: {
			matchers: [],
			folderStructure: "mail2Cloud/EmailSync/Integration/Test/${subject}",
			attachmentsSubfolder: null,
			originalEmailSubfolder: null,
			bodySubfolder: null
		},
		security: {
			scope: "anyone",
			canDownload: true,
			expireAccessInSeconds: 0,
			entity: null,
			overwrite: false
		},
		assets: {
			doNotOverwrite: false,
			emails: {
				deleteOriginal: false,
				patternFile: "${subject}",
				storageFormats: [{
					format: "pdf",
					subfolder: "email",
					eml: false,
					pdf: true
				}, {
					format: "eml",
					subfolder: "body",
					eml: true,
					pdf: false
				}]
			},
			documents: {
				store: true,
				sizeInBytes: null,
				replaceByLinks: true,
				contentTypes: [],
				extensions: [],
				subfolder: "attachments",
				contentTypeImagesSet: false
			}
		},
		notification: {
			onError: true,
			onSuccess: true,
			mailAddress: "jproyo@mxhero.com",
			source: "dashboard-3.0"
		}
	},
	wasNotified: true,
	amountEmailsProcessed: 2,
	amountFilesSync: 6,
	amountEmailsError: 0,
	amountAccounts: 1,
	amountAccountsRunning: -1,
	amountAccountsFinished: 1,
	amountAccountsError: 0,
	amountAccountsFinishedWithError: 0,
	notRecursiveOrPeriodFinished: true,
	recursive: false,
	finished: true
}]
	
=end

	def test_all
		VCR.use_cassette('emailsync_fetch_all') do
			response = @emailsync.all(domain)
			assert response.success?
			assert response.msg
		end
	end

	def test_request_all
		VCR.use_cassette('emailsync_fetch_all') do
			response = @emailsync.request(domain, :get, '/')
			assert response.ok?
			assert response.content
		end
	end

	def test_task_by_id
		VCR.use_cassette('emailsync_task_by_id') do
			response = @emailsync.task_by_id(domain, '031ad948-8e56-4035-a976-aa6400b0b261')
			assert response.success?
			assert response.msg
			assert response.msg[:taskId] == '031ad948-8e56-4035-a976-aa6400b0b261'
		end
	end

	def test_request_task_by_id
		VCR.use_cassette('emailsync_task_by_id') do
			response = @emailsync.request(domain, :get, '/031ad948-8e56-4035-a976-aa6400b0b261')
			assert response.ok?
			assert response.content
			assert response.content.include? '"taskId":"031ad948-8e56-4035-a976-aa6400b0b261"'
		end
	end

	def test_delete
		VCR.use_cassette('emailsync_delete') do
			response = @emailsync.delete(domain, '031ad948-8e56-4035-a976-aa6400b0b261')
			assert response.success?
			assert response.msg.empty?
			assert_equal({}, response.msg)
		end
	end

end